"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.reset = exports.popToTop = exports.pop = exports.goBack = exports.push = exports.navigate = exports.navigationRef = exports.isReadyRef = void 0;
const tslib_1 = require("tslib");
const React = tslib_1.__importStar(require("react"));
const native_1 = require("@react-navigation/native");
exports.isReadyRef = React.createRef();
exports.navigationRef = React.createRef();
const navigate = (routeName, params) => {
    if (exports.isReadyRef.current && exports.navigationRef && exports.navigationRef.current) {
        // Perform navigation if the app has mounted
        exports.navigationRef?.current?.navigate(routeName, params);
    }
};
exports.navigate = navigate;
const push = (routeName, params) => {
    if (exports.isReadyRef.current && exports.navigationRef && exports.navigationRef.current) {
        // Perform navigation if the app has mounted
        exports.navigationRef.current.dispatch(native_1.StackActions.push(routeName, params));
    }
};
exports.push = push;
const goBack = () => {
    if (exports.isReadyRef.current && exports.navigationRef && exports.navigationRef.current) {
        // Perform navigation if the app has mounted
        exports.navigationRef.current.goBack();
    }
};
exports.goBack = goBack;
const pop = (...args) => {
    if (exports.isReadyRef.current && exports.navigationRef && exports.navigationRef.current) {
        // Perform navigation if the app has mounted
        exports.navigationRef.current?.dispatch(native_1.StackActions.pop(...args));
    }
};
exports.pop = pop;
const popToTop = () => {
    if (exports.isReadyRef.current && exports.navigationRef && exports.navigationRef.current) {
        // Perform navigation if the app has mounted
        exports.navigationRef.current?.dispatch(native_1.StackActions.popToTop());
    }
};
exports.popToTop = popToTop;
const reset = (...args) => {
    if (exports.isReadyRef.current && exports.navigationRef && exports.navigationRef.current) {
        // Perform navigation if the app has mounted
        exports.navigationRef.current?.reset(...args);
    }
};
exports.reset = reset;
//# sourceMappingURL=NavigationService.js.map